#!/usr/bin/perl

# Use whereis to find perl on your web server			#
# Tested with Perl 5.004	version 1.1a				#

# IN-A-FLASH(TM), a trademark of Virtual Light Studios	#
# This code is (C) 2000 Virtual Light Studios (VLS)		#
# Do not distribute without this notice					#
# Cannot be resold										#
# VLS is not responsible for anything bad that might	#
# happen because you used this software, nor does VLS	#
# guarantee this software will work for you				#

@referers = ('tangible.new21.org');
# Add your web server to referers

&check_url;

#### Check Referer ####

sub check_url { 

	if ($ENV{'HTTP_REFERER'}) {
		foreach $referer (@referers) {
			if ($ENV{'HTTP_REFERER'} =~ m|https?://([^/]*)$referer|i) {
				last;
			} else {
				die;
            }
		} 
	}
}

#### Define Variables ####

# Incremented mail number
$messagenumberfile = "number.txt";
# message file extension
$ext = "txt";
$listofmessages = "messagelist.txt";
$filelock = "number.lock";

#$realname: name of message author
#$which: file name (minus extension) of message to be read
#$email: e-mail address of message author
#$replylist: comma delimited list of replies to original message
#$notify: whether message author wanted to be sent emails of replies
#$url: home page, ftp address of message author
#$message: the actual message
#$subject: subject of message
#$forumdirectory: the directory of this forum
#$basedirectory: directory where all forums reside
#$messagelimit: when to engage auto-purge feature
#$linecount: the number of lines in messagelist (thus, the number of messages)
#$eof: a message sent back to the Flash movie that the operation requested has finished
#$original: $original is the message that the reply you're reading is referring to

#### Determine Action ####

	if ($ENV{'REQUEST_METHOD'} eq 'GET') {
		# Split the name-value pairs
		@pairs = split(/&/, $ENV{'QUERY_STRING'});
	} else {
		read(STDIN, $ARGV[0], $ENV{'CONTENT_LENGTH'});
		@pairs = split(/&/, $ARGV[0]);
	}

	&parse_form; # reads in name/value pairs sent to the cgi from the Flash movie
	
	if ($FORM{'todo'} eq 'list' ) { &print_list; }
	if ($FORM{'todo'} eq 'delete' ) { &delete_message; }
	if ($FORM{'todo'} eq 'read' ) { &read_messages; }
	if ($FORM{'todo'} eq 'post' ) { &post_message; }
	if ($FORM{'todo'} eq 'reply' ) { &post_reply; }


#### Delete message ####

sub delete_message {

	&simplify_variables; &lock_check; 

	open (LISTFILE,"$basedirectory/$forumdirectory/$listofmessages");
	@previous = <LISTFILE>;
	close (LISTFILE);

	@which = split(/,/, $deletelist);
	open(LISTFILE,">$basedirectory/$forumdirectory/$listofmessages");
	
	if ($original) {
		&determine_which ($which);
		splice(@previous,$whichline,1); # delete reply listing

		&determine_which ($original);
		%fields = eval($previous[$whichline]); 
		$fields{replies}--;
		if ($fields{replies} == 0) {$fields{replies} = " "; }
		$fields{replylist} =~ s/$which,//; # delete reply from replylist
		
		# update original message entry in messagelist w/replylist and number of replies
		$temp = '("file","'  .  $fields{file}  .  '","realname","'  .  $fields{realname};
		$temp .= '","replies","'  .  $fields{replies} . '","replylist","' . $fields{replylist};
		$temp .= '","subject","' . $fields{subject} . '","date","' . $fields{date} . '")' . "\n";
		$previous[$whichline] = $temp;
		
		@stats =  stat("$basedirectory/$forumdirectory/$original\.$ext");
		open(MESSAGE,"$basedirectory/$forumdirectory/$original\.$ext");
		read(MESSAGE,$temp,$stats[7]); #$stat[7] is size in bites of message file
		@temp = split(/&/, $temp);
		foreach $temp (@temp) {
			($name, $value) = split(/=/, $temp);
			$value =~ tr/+/ /;
			$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
			$value =~ s/<!--(.|\n)*-->//g;      # Gets rid of server-side includes
			$fields{$name} = $value;
		}

		close(MESSAGE);
		$fields{replies}--;
		if ($fields{replies} == 0) {$fields{replies} = " "; }
		$fields{replylist} =~ s/$which,//; # delete reply from replylist
		open(MESSAGE,">$basedirectory/$forumdirectory/$original\.$ext");
		print MESSAGE "email=$fields{'email'}&realname=$fields{'realname'}&subject=$fields{'subject'}&";
		print MESSAGE "url=$fields{'url'}&notify=$fields{'notify'}&message=$fields{'message'}&";
		print MESSAGE "date=$fields{'date'}&replylist=$fields{'replylist'}";

		close(MESSAGE);

	} else {
		foreach $which (@which) {
			&determine_which ($which);
			splice(@previous,$whichline,1); # delete original and, if any, replies
		}
	}
	
	foreach $previous(@previous) {
		print LISTFILE $previous; #print back the updated messagelist
	}
	
	close (LISTFILE);
	
	foreach $which (@which) {
		unlink("$basedirectory/$forumdirectory/$which.$ext"); # delete message		
	}
	unlink("$basedirectory/$forumdirectory/$filelock"); # delete lock file
	
	print "Content-type: text/html\n\n";
	print "status=. . . file deleted . . .";
}

#### Read In Form Fields (everybody uses this) ####

sub parse_form {

	foreach $pair (@pairs) {
		($name, $value) = split(/=/, $pair);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value =~ s/<!--(.|\n)*-->//g;      # Gets rid of server-side includes
		$FORM{$name} = $value;
	}
}

#### Print List ####

sub print_list {

	&simplify_variables;
	
	open (LISTFILE,"$basedirectory/$forumdirectory/$listofmessages");
	@line = <LISTFILE>;
	$linecount=@line; # linecount equals number of messages
	close (LISTFILE);
	
	# next bit fills out the files, subjects, dates, etc. variables in the Flash movie
	foreach $line(@line) {
		%fields = eval($line);
		$files .= $fields{file} . ","; $emails .= $fields{realname} . "\n";
		$subjects .= $fields{subject} . "\n"; $dates .= $fields{date} . "\n";
		$replies .= $fields{replies} . "\n";
	}
	
	print "Content-type: text/html\n\n";
	print "files=$files&emails=$emails&subjects=$subjects&dates=$dates&replies=$replies";
	print "&linecount=$linecount&messagelimit=$messagelimit&eof=true";
}

#### Reply ####

sub post_reply {

	&simplify_variables;
	
	&date_time;
	
	open(APPENDFILE,"$basedirectory/$forumdirectory/$which\.$ext");
	$replytest = <APPENDFILE>; $position = index($replytest,"replylist=");
	close(APPENDFILE);
	
	open(APPENDFILE,">>$basedirectory/$forumdirectory/$which\.$ext");
	
	&get_number;

	if ($position == -1) {
		print APPENDFILE "$num,";
	} else {
		print APPENDFILE "$num,";
	}
	close(APPENDFILE);
		
	$reply = "yes";
	
	&determine_which ($which);
	$temp = '("file","'  .  $num  .  '","realname","'  .  $realname;
	$temp .= '","replies","*","original","' . $which;
	$temp .= '","subject","' . $subject . '","date","' . $date . '")' . "\n";
	splice(@previous,$whichline+1,0,$temp); # slides replies under orig message
	
	%fields = eval($previous[$whichline]); # @previous obtained in &get_number, $whichline in determine_which
	$fields{replies}++; $fields{replylist} .= "$num,";
		
	# update original message entry in messagelist w/replylist and number of replies
	$temp = '("file","'  .  $fields{file}  .  '","realname","'  .  $fields{realname};
	$temp .= '","replies","'  .  $fields{replies} . '","replylist","' . $fields{replylist};
	$temp .= '","subject","' . $fields{subject} . '","date","' . $fields{date} . '")' . "\n";
	$previous[$whichline] = $temp;
		
	open(LISTFILE,">$basedirectory/$forumdirectory/$listofmessages");
	foreach $previous(@previous) {
		print LISTFILE $previous;
	}
	close(LISTFILE);
	
	&create_message_file;

	&increment_num;
}

#### Create New Message File / Update List of Messages ####

sub create_message_file {
	
	# create new message based on incrementing number
	open(NEWFILE,">$basedirectory/$forumdirectory/$num\.$ext");
	
	print NEWFILE "email=$email&realname=$realname&subject=$subject&url=$url";
	if ($reply eq "yes") {
		print NEWFILE "&reply=$reply&original=$which&message=$message&date=$long_date";
	} else {
		print NEWFILE "&notify=$notify&message=$message&date=$long_date&replylist=";
	}
	close(NEWFILE);
	
	if (!$reply) {
		open(LISTFILE,">$basedirectory/$forumdirectory/$listofmessages");
		print LISTFILE '("file","'  .  $num  .  '","realname","'  .  $realname . '","replies"," ",';
		print LISTFILE '"subject","' . $subject . '","date","' . $date . '","replylist","")' . "\n";
		print LISTFILE @previous;
		close(LISTFILE);
	}
	
	print "Content-type: text/html\n\n"; print "eof=true";
	
	unlink("$basedirectory/$forumdirectory/$filelock"); # delete lock file
}

#### Post Message ####

sub post_message {
	
	&simplify_variables;
	
	&get_number;
	
	&date_time;
	
	&create_message_file;
   
	&increment_num;
}

#### Lock Check ####

sub lock_check {

	# Next bit checks whether another process (copy) of this cgi has already
	# created a lock file (is trying to save a message)
	while(-f "$basedirectory/$forumdirectory/$filelock") {
		select (undef,undef,undef,0.1); # keeps waiting a tenth of a second
	}
	open (LOCKFILE,">$basedirectory/$forumdirectory/$filelock"); # create own lock file
	close(LOCKFILE);
}

#### Get Data Number ####

sub get_number {
	
	&lock_check;
	
	open(LISTFILE,"$basedirectory/$forumdirectory/$listofmessages");
	@previous = <LISTFILE>; $temp = @previous;
	close(LISTFILE);

	open(NUMBER,"$basedirectory/$forumdirectory/$messagenumberfile");
	$num = <NUMBER>;
	close(NUMBER);
	if ($temp > $messagelimit)  {
		 $num++; &weed_files; # purge files over the $messagelimit
	} else {
		$num++;
	}
}

#### Weed Files ####

sub weed_files {
	$temp=@previous;
	%fields = eval($previous[$temp-1]);
	if (!$fields{original}) {
		splice(@previous,$temp-1,1);
		@files_to_delete[0] = "$fields{file}";
	} else {
		&determine_which($fields{original});
		%fields = eval($previous[$whichline]);
		$fields{replylist} .= $fields{file};
		@files_to_delete = split(/,/,$fields{replylist});
		splice(@previous,$whichline,$fields{replies}+1); # note $whichline+1, $fields{replies}+1
	}
	open(LISTFILE,">$basedirectory/$forumdirectory/$listofmessages");
	foreach $previous(@previous) {
		print LISTFILE $previous;
	}
	close(LISTFILE);
	
	foreach $files_to_delete(@files_to_delete) {
		$files_to_delete = "$basedirectory/$forumdirectory/" . $files_to_delete . ".$ext";
	}

	unlink(@files_to_delete); # deletes files in @files_to_delete array
}

#### Determine Which Message ####

sub determine_which {
	my($which) = @_; # creates local variable $which

	$xx=0;
	foreach $previous(@previous) { # @previous obtained in &get_number
		%temp = eval($previous);
		if ($temp{file} eq $which) {
			 $whichline = $xx; last;
		} 
		$xx++;
	}
}

#### Read Message ####

sub read_messages {

	&simplify_variables;

	if (open(MESSAGE,"$basedirectory/$forumdirectory/$which\.$ext") ) {
	
		@message = <MESSAGE>;
		close(MESSAGE);
		print "Content-type: text/html\n\n"; print @message; print "&eof=true";
		
	} else {
		print "Content-type: text/html\n\n"; print "status=. . . this message was deleted . . ."; 
		print "&email=&subject=&realname=&message=&date=";
		die;
	}
}

#### Simplify Variables ####

sub simplify_variables {
	
	$realname = "$FORM{'realname'}";
	$which = "$FORM{'which'}";
	$original = "$FORM{'original'}";
	$deletelist = "$FORM{'deletelist'}";
	$email = "$FORM{'email'}";
	$replylist = "$FORM{'replylist'}";
	$notify = "$FORM{'notify'}";	
	$url = "$FORM{'url'}";
	$message = "$FORM{'message'}";	
	$subject = "$FORM{'subject'}";
	$forumdirectory = "$FORM{'forumdirectory'}";
	$basedirectory = "$FORM{'basedirectory'}";
	$messagelimit = "$FORM{'messagelimit'}";
}

#### Increment Message Number ####

sub increment_num {

	open(NUMBER,">$basedirectory/$forumdirectory/$messagenumberfile");
	print NUMBER "$num";
	close(NUMBER);
}

#### Date and Time ####

sub date_time {

	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

	if ($sec < 10) { $sec = "0$sec"; }
	if ($min < 10) { $min = "0$min"; }
	if ($hour < 10) { $hour = "0$hour"; }
	if ($mon < 10) { $mon = "0$mon"; }
	if ($mday < 10) { $mday = "0$mday"; }

	$month = ($mon + 1);

	@months = ("January","February","March","April","May","June","July","August","September","October","November","December");

	$year += 1900; # remember, Perl's two digit year is the difference between current year and 1900
	$long_date = "$months[$mon] $mday, $year at $hour\:$min\:$sec";

	$year %= 100;
	if ($year < 10) { $year = "0$year"; };

	$date = "$month.$mday.$year";
	
	$hrsec = " $hour:$min";
}
